---
title: RTCPeerConnection.oniceconnectionstatechange
slug: Web/API/RTCPeerConnection/oniceconnectionstatechange
tags:
  - Event Handler
  - Experimental
  - Property
  - RTCPeerConnection
  - Reference
  - WebRTC
  - oniceconnectionstatechange
---
<p>{{APIRef("WebRTC")}}{{SeeCompatTable}}</p>

<p>The <code><strong>RTCPeerConnection.oniceconnectionstatechange</strong></code> property is an event handler which specifies a function to be called when the {{event("iceconnectionstatechange")}} event is fired on an {{domxref("RTCPeerConnection")}} instance. This happens when the state of the connection's ICE agent, as represented by the {{domxref("RTCPeerConnection.iceConnectionState", "iceConnectionState")}} property, changes.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>RTCPeerConnection</em>.oniceconnectionstatechange = <em>eventHandler</em>;
</pre>

<h3 id="Value">Value</h3>

<p>This event handler can be set to function which is passed a single input parameter: an {{domxref("Event")}} object describing the {{event("iceconnectionstatechange")}} event which occurred. Your code can look at the value of {{domxref("RTCPeerConnection.iceConnectionState")}} to determine what the new state is.</p>

<h2 id="Example">Example</h2>

<p>The example below watches the state of the ICE agent for a failure or unexpected closure and takes appropriate action, such as presenting an error message or attempting to restart the ICE agent.</p>

<pre class="brush: js">pc.oniceconnectionstatechange = function(event) {
  if (pc.iceConnectionState === "failed" ||
      pc.iceConnectionState === "disconnected" ||
      pc.iceConnectionState === "closed") {
    // Handle the failure
  }
};
</pre>

<p>Of course, "disconnected" and "closed" don't necessarily indicate errors; these can be the result of normal ICE negotiation, so be sure to handle these properly (if at all).</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#dom-rtcpeerconnection-oniceconnectionstatechange', 'RTCPeerConnection.oniceconnectionstatechange') }}</td>
   <td>{{ Spec2('WebRTC 1.0') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.oniceconnectionstatechange")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{event("iceconnectionstatechange")}} event and its type, {{domxref("Event")}}.</li>
</ul>
